include 'Vram.inc'
include 'VVram.inc'

ext VVram_
ext InitPatterns_

VramSize equ VramWidth * VramHeight
VramTop equ Vram

cseg
Fill:
    ld bc, VramSize
    do
        ld (hl),e
        inc hl
        dec bc
        ld a,c
        or b
    while nz | wend
ret

; void InitVram();
cseg
InitVram_: public InitVram_
    ld hl,TextVram
    ld e,0
    call Fill

    ld hl,Attributes
    ld e,70h
    call Fill

    ld hl, HighVram
    ld e,08h
    call Fill

    ld a,3
    out (0f0h),a

    call InitPatterns_
ret


; void ClearScreen();
ClearScreen_:
    public ClearScreen_
    push af | push hl | push bc
        ld hl,Vram
        ld bc,VramWidth*VramHeight
        do
            ld (hl),0
            inc hl
            dec bc
            ld a,c
            or b
        while nz | wend
    pop bc | pop hl | pop af
ret


; void VVramToVram();
cseg
VVramToVram_: public VVramToVram_
    push af | push hl | push de | push bc
        ld de,VVram_
        ld hl,VramTop
        ld c,VVramHeight ; vertical count    
        do
                ld b,VVramWidth
                do 
                    ld a,(de)
                    inc de
                    ld (hl),a
                    inc hl
                dwnz
                push bc
                    ld bc,VramWidth-VVramWidth
                    add hl,bc
                pop bc
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; ptr<byte> PrintC(ptr<byte> address, byte c);
cseg
PrintC_: public PrintC_
    push af
        ld a,e
        sub ' '
        ld (hl),a
        inc hl
    pop af
ret


; WriteColorPattern(ptr<byte> pPattern, ptr<byte> pSource, byte count);
cseg
WriteColorPattern_: public WriteColorPattern_
    push af | push hl | push de | push bc
        do
            push bc
                ld a,1
                do
                    push hl
                        out (0e5h),a
                        ex de,hl
                            ld bc,8
                            ldir
                        ex de,hl
                    pop hl
                    inc a
                    cp 4
                while nz | wend
                ld bc, CharHeight
                add hl,bc
            pop bc
            dec c
        while nz | wend
        out (0e6h),a
    pop bc | pop de | pop hl | pop af
ret


; void WriteMonoPattern(ptr<byte> pPattern, ptr<byte> pSource, byte color, byte count);
dseg
WriteMonoPattern_@Param3: public WriteMonoPattern_@Param3
    defb 0
cseg
WriteMonoPattern_: public WriteMonoPattern_
    push af | push hl | push de | push bc
        ld a,(WriteMonoPattern_@Param3)
        ld b,a
        do
            push bc
                ld a,1
                do
                    push hl
                        out (0e5h),a
                        bit 0,c
                        if nz
                            push de | push bc
                                ex de,hl
                                    ld bc,CharHeight
                                    ldir
                                ex de,hl
                            pop bc | pop de
                        else
                            push bc
                                ld b,CharHeight
                                do
                                    ld (hl),0
                                    inc hl
                                dwnz
                            pop bc
                        endif
                    pop hl
                    srl c
                    inc a
                    cp 4
                while nz | wend
                ld bc, CharHeight
                add hl,bc
                ex de,hl
                    add hl,bc
                ex de,hl
            pop bc
        dwnz
        out (0e6h),a
    pop bc | pop de | pop hl | pop af
ret
